package com.sample;

import java.util.ArrayList;
import java.util.List;

public class ImportRowsGenerator {

	private static final int LINES_TO_GENERATE = 1280;
	private static final int MAX_FIELD_LENGTH = 15;

	private static final char[] chars = { 'A', 'B', 'C', 'D', 'E', 'F', 'G',
			'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
			'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
			'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
			'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6',
			'7', '8', '9' };

	public static List<ImportRow> generateImportRows() {
		return generateImportRows(LINES_TO_GENERATE);
	}

	public static List<ImportRow> generateImportRows(int linesToGenerate) {
		List<ImportRow> importRows = new ArrayList<ImportRow>();

		int charsLength = chars.length;

		for (int i = 0; i < linesToGenerate; i++) {
			int recordType = i == 0 ? 1 : (i == linesToGenerate - 2 ? 4
					: (i == linesToGenerate - 1 ? 5 : 3));
			int fieldCount = recordType == 1 ? 3 : (recordType == 3 ? 22
					: (recordType == 4 ? 4 : 3));

			String nextLine = "";
			for (int j = 0; j < fieldCount; j++) {
				if (j != 0) {
					int fieldLength = (int) Math.floor(Math.random()
							* (MAX_FIELD_LENGTH + 1));
					for (int k = 0; k < fieldLength; k++) {
						int r = (int) Math.floor(Math.random() * charsLength);
						nextLine += chars[r];
					}
				} else {
					nextLine += Integer.toString(recordType);
				}

				if (j < fieldCount - 1) {
					nextLine += ",";
				}
			}

			importRows.add(new ImportRow(i + 1, nextLine));

		}

		return importRows;

	}
}
