package com.sample;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.event.rule.DebugAgendaEventListener;
import org.drools.event.rule.DebugWorkingMemoryEventListener;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

public class ProcessTest {

	private static final int LINES_TO_GENERATE = 1000;
	private static final int SUB_LIST_SIZE = 100;

	public static final void main(String[] args) {
		try {
			KnowledgeBase kbase = readKnowledgeBase();
			StatefulKnowledgeSession ksession = kbase
					.newStatefulKnowledgeSession();

//			ksession.addEventListener(new DebugAgendaEventListener());
//			ksession.addEventListener(new DebugWorkingMemoryEventListener());

			// KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory
			// .newFileLogger(ksession, "test");

			List<ImportRow> testList = ImportRowsGenerator
					.generateImportRows(LINES_TO_GENERATE);

			Map<String, Object> processProperties = new HashMap<String, Object>();
			processProperties.put("testList", testList);
			processProperties.put("subListSize", SUB_LIST_SIZE);

			ksession.startProcess("com.sample.bpmn.hello", processProperties);
			ksession.fireAllRules();
			// logger.close();
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory
				.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("sample.bpmn"),
				ResourceType.BPMN2);
		kbuilder.add(ResourceFactory.newClassPathResource("validation.drl"),
				ResourceType.DRL);
		return kbuilder.newKnowledgeBase();
	}

}